## fcitx 4.2.6.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(fcitx)

set(version 4.2.6.1)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

option(ENABLE_X11 "Enable X11 as dependency" ON)
option(ENABLE_GLIB2 "Enable GLib2 as depenedency" ON)
option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_LIBXML2 "Enable libxml2" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" OFF)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(ENABLE_LUA "Enable Lua support" OFF)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)
option(ENABLE_GIR "Enable GObject Introspection" On)
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" On)
option(FORCE_ENCHANT
  "Enable enchant even if the library is not found at compile time" Off)
option(FORCE_PRESAGE
  "Enable presage even if the library is not found at compile time" Off)
option(ENABLE_ICU "Enable icu for qt/keyboard compose" On)
option(ENABLE_BACKTRACE "Enable backtrace support" On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installion" On)

if (NOT NO_SNOOPER_APPS)
set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*" CACHE STRING "Disable Key Snooper for following app")
endif (NOT NO_SNOOPER_APPS)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

find_package(Gettext REQUIRED)
find_package(Libintl REQUIRED)
find_package(Libiconv REQUIRED)
find_package(Pthread REQUIRED)

find_package(Libexecinfo)

if (LIBEXECINFO_LIB_FOUND)
    set(ENABLE_BACKTRACE 1)
else (LIBEXECINFO_LIB_FOUND)
    set(ENABLE_BACKTRACE 0)
endif (LIBEXECINFO_LIB_FOUND)

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
    find_package(Libkvm REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
find_package(DL REQUIRED)
if(ENABLE_ENCHANT)
  find_package(Enchant)
  if(NOT (ENCHANT_FOUND OR FORCE_ENCHANT))
    set(ENABLE_ENCHANT Off)
  endif()
endif()
if (ENABLE_LIBXML2)
    find_package(LibXml2 REQUIRED)
    find_package(IsoCodes REQUIRED)
    find_package(XkbFile REQUIRED)
endif (ENABLE_LIBXML2)
if(ENABLE_PRESAGE)
  find_package(Presage)
  if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
    set(ENABLE_PRESAGE Off)
  endif()
endif()
if (ENABLE_ICU)
    find_package(ICU REQUIRED)
endif (ENABLE_ICU)

FIND_PROGRAM(WGET wget)
FIND_PROGRAM(TAR tar)

if(ENABLE_X11)
find_package(X11 REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

find_program(some_x_program NAMES iceauth xrdb xterm)
if (NOT some_x_program)
    _pkgconfig_invoke("x11" PC_X11 PREFIX "" "--variable=prefix")
    if (PC_X11_PREFIX)
        set(some_x_program "${PC_X11_PREFIX}/bin/xrdb")
    else (PC_X11_PREFIX)
        set(some_x_program /usr/bin/xrdb)
        message("Warning: Could not determine X binary directory. Assuming /usr/bin.")
    endif (PC_X11_PREFIX)
endif (NOT some_x_program)
get_filename_component(proto_xbindir "${some_x_program}" PATH)
get_filename_component(XBINDIR "${proto_xbindir}" ABSOLUTE)
get_filename_component(xrootdir "${XBINDIR}" PATH)
set(XLIBDIR "${xrootdir}/lib/X11")
endif(ENABLE_X11)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_X11 AND ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib>=1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_X11 AND ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO AND ENABLE_GLIB2)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo>=1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO AND ENABLE_GLIB2)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1>=1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

set(_ENABLE_OPENCC 0)
if (ENABLE_OPENCC)
    PKG_CHECK_MODULES(OPENCC "opencc>=0.1.1" )
    if (OPENCC_FOUND)
        set(_ENABLE_OPENCC 1)
    endif (OPENCC_FOUND)
endif (ENABLE_OPENCC)

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if (X11_Xfixes_FOUND)
    set(HAVE_XFIXES 1)
endif (X11_Xfixes_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${exec_prefix}/lib)
endif()

set(libdir ${LIB_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)
set(includedir  ${CMAKE_INSTALL_PREFIX}/include)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
  set(ENCHANT_LIBRARY_FILENAME
    "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()
if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
  set(PRESAGE_LIBRARY_FILENAME
    "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(cmake)

if (ENABLE_TEST)
    add_subdirectory(test)
endif (ENABLE_TEST)

=== data/CMakeLists.txt ===
if (ENABLE_TABLE)
    add_subdirectory(table)
endif (ENABLE_TABLE)

add_subdirectory(script)
add_subdirectory(icon)

set(FCITX_DESC_FILES
    addon.desc
    config.desc
    profile.desc
    inputmethod.desc
)

set(FCITX_DATA_FILES
    AutoEng.dat
    gbks2t.tab
    punc.mb.zh_CN
    punc.mb.zh_HK
    punc.mb.zh_TW
    vk.conf
    ${CMAKE_CURRENT_BINARY_DIR}/en_dict.fscd
)

set(FCITX_PY_FILES
    pySym.mb
    sp.dat
)

set(FCITX_DSEKTOP_FILES
    fcitx.desktop
    fcitx-configtool.desktop
    fcitx-autostart.desktop
)

set(PY_ORGDATA pyPhrase.org)
set(PY_DATA ${CMAKE_CURRENT_BINARY_DIR}/pybase.mb ${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb)
set(PY_TAR ${CMAKE_CURRENT_SOURCE_DIR}/pinyin.tar.gz)
set(PY_URL http://fcitx.googlecode.com/files/pinyin.tar.gz)


intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx-configtool.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop )
intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop )
intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx-autostart.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop )

add_custom_target(pinyin_data ALL DEPENDS ${PY_DATA})

add_custom_command(OUTPUT ${PY_ORGDATA}
                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/download.sh "${WGET}" "${PY_URL}" "${PY_TAR}"
                   COMMAND ${TAR} xzmvf ${PY_TAR})
add_custom_command(OUTPUT ${PY_DATA}
                   DEPENDS ${PY_ORGDATA}
                   COMMAND createPYMB ${CMAKE_CURRENT_SOURCE_DIR}/gbkpy.org ${CMAKE_CURRENT_BINARY_DIR}/${PY_ORGDATA})

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop DESTINATION share/applications/)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop DESTINATION share/applications/)

install(FILES ${FCITX_DATA_FILES} DESTINATION ${pkgdatadir}/data)
fcitx_add_configdesc_file(${FCITX_DESC_FILES})
install(FILES ${FCITX_PY_FILES} ${CMAKE_CURRENT_BINARY_DIR}/pybase.mb ${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb DESTINATION ${pkgdatadir}/pinyin)

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/pyERROR,${CMAKE_CURRENT_BINARY_DIR}/pyPhrase.ok")

if (_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop DESTINATION /etc/xdg/autostart)
endif (_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)

if (_ENABLE_DBUS)
install(FILES daemon.conf DESTINATION share/fcitx/dbus/)
endif (_ENABLE_DBUS)

set(SPELL_EN_DICT_VER 20120815)
set(SPELL_EN_DICT en_dict.fscd)
set(SPELL_EN_DICT_SRC en_dict.txt)
set(SPELL_EN_DICT_TAR ${CMAKE_CURRENT_SOURCE_DIR}/en_dict-${SPELL_EN_DICT_VER}.tar.gz)
set(SPELL_EN_DICT_URL
    https://github.com/downloads/fcitx/fcitx/en_dict-${SPELL_EN_DICT_VER}.tar.gz)

add_custom_target(spell_en_dict ALL DEPENDS ${SPELL_EN_DICT})
add_custom_command(
  OUTPUT ${SPELL_EN_DICT_SRC}
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/download.sh "${WGET}"
  "${SPELL_EN_DICT_URL}" "${SPELL_EN_DICT_TAR}"
  COMMAND "${TAR}" xzmvf "${SPELL_EN_DICT_TAR}")

set(COMP_SPELL_DICT
  "${PROJECT_BINARY_DIR}/src/module/spell/dict/comp-spell-dict")
add_custom_command(
  OUTPUT ${SPELL_EN_DICT}
  DEPENDS ${SPELL_EN_DICT_SRC} "${COMP_SPELL_DICT}"
  COMMAND "${COMP_SPELL_DICT}" "${SPELL_EN_DICT_SRC}" "${SPELL_EN_DICT}")

=== test/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/lib)
include_directories(${PROJECT_SOURCE_DIR}/src/im/pinyin)
include_directories(${PROJECT_SOURCE_DIR}/src/module/unicode)
include_directories(${PROJECT_SOURCE_DIR}/src/module/dbus)

add_executable(testbacktrace testbacktrace.c)
target_link_libraries(testbacktrace fcitx-utils)

add_executable(testconfig testconfig.c)
target_link_libraries(testconfig fcitx-config)

add_executable(testmessage testmessage.c)
target_link_libraries(testmessage fcitx-core)

add_executable(teststring teststring.c)
target_link_libraries(teststring fcitx-utils)

add_executable(testarray testarray.c)
target_link_libraries(testarray fcitx-utils)

add_executable(testutf8 testutf8.c)
target_link_libraries(testutf8 fcitx-utils)

add_executable(testxdg testxdg.c)
target_link_libraries(testxdg fcitx-config fcitx-utils)

add_executable(testunicode testunicode.c ../src/module/unicode/charselectdata.c)
target_link_libraries(testunicode fcitx-utils fcitx-config)

add_executable(testpinyin
    ../src/im/pinyin/pyParser.c
    ../src/im/pinyin/pyMapTable.c
    ../src/im/pinyin/PYFA.c
    ../src/im/pinyin/sp.c
    testpinyin.c
)

target_link_libraries(testpinyin fcitx-config)

add_executable(testdbuslaunch testdbuslaunch.c
               ../src/module/dbus/dbuslauncher.c
               )

add_test(NAME testconfig
         COMMAND testconfig ${CMAKE_CURRENT_SOURCE_DIR}/test.desc ${CMAKE_CURRENT_SOURCE_DIR}/test.conf ${CMAKE_CURRENT_BINARY_DIR}/test.conf)

add_test(NAME testmessage
         COMMAND testmessage)

add_test(NAME testbacktrace
         COMMAND testbacktrace)

add_test(NAME testpinyin
         COMMAND testpinyin)

add_test(NAME teststring
         COMMAND teststring)

add_test(NAME testarray
         COMMAND testarray)

add_test(NAME testutf8
         COMMAND testutf8)

add_test(NAME testxdg
         COMMAND testxdg)

add_test(NAME testunicode
         COMMAND testunicode ${PROJECT_SOURCE_DIR}/src/module/unicode/charselectdata)

add_test(NAME testdbuslaunch
         COMMAND testdbuslaunch)

=== tools/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/)
include_directories(${LIBICONV_INCLUDE_DIR})

set(createPYMB_SOURCES
    createPYMB.c
    ../src/im/pinyin/pyParser.c
    ../src/im/pinyin/pyMapTable.c
    ../src/im/pinyin/PYFA.c
    ../src/im/pinyin/sp.c
)

set(mb2org_SOURCES
    mb2org.c
    pyTools.c
    ../src/im/pinyin/pyParser.c
    ../src/im/pinyin/pyMapTable.c
    ../src/im/pinyin/PYFA.c
    ../src/im/pinyin/sp.c
)

set(readPYBase_SOURCES
    readPYBase.c
    pyTools.c
)

set(readPYMB_SOURCES
    readPYMB.c
    pyTools.c
)

set(mb2txt_SOURCES
    mb2txt.c
)

set(txt2mb_SOURCES
    txt2mb.c
)

set(scel2org_SOURCES
    scel2org.c
)

add_executable(createPYMB ${createPYMB_SOURCES})
add_executable(readPYBase ${readPYBase_SOURCES})
add_executable(readPYMB ${readPYMB_SOURCES})
add_executable(mb2org ${mb2org_SOURCES})
add_executable(mb2txt ${mb2txt_SOURCES})
add_executable(txt2mb ${txt2mb_SOURCES})
add_executable(scel2org ${scel2org_SOURCES})

target_link_libraries(createPYMB fcitx-config fcitx-utils)
target_link_libraries(readPYBase fcitx-config)
target_link_libraries(readPYMB fcitx-config)
target_link_libraries(mb2org fcitx-config)
target_link_libraries(mb2txt fcitx-config fcitx-utils)
target_link_libraries(txt2mb fcitx-config fcitx-utils)
target_link_libraries(scel2org ${LIBICONV_LIBRARIES})

install(TARGETS createPYMB readPYBase readPYMB mb2org mb2txt txt2mb scel2org DESTINATION ${bindir})

if (NOT _ENABLE_DBUS)
add_executable(fcitx-remote fcitx-remote.c)
target_link_libraries(fcitx-remote fcitx-utils)
install(TARGETS fcitx-remote DESTINATION ${bindir})
endif (NOT _ENABLE_DBUS)

=== src/module/CMakeLists.txt ===
if (ENABLE_X11)
add_subdirectory(x11)
endif (ENABLE_X11)

if (ENABLE_X11 AND ENABLE_LIBXML2)
add_subdirectory(xkb)
endif (ENABLE_X11 AND ENABLE_LIBXML2)

if (_ENABLE_DBUS AND ENABLE_X11 AND ENABLE_LIBXML2)
    add_subdirectory(xkbdbus)
endif (_ENABLE_DBUS AND ENABLE_X11 AND ENABLE_LIBXML2)

add_subdirectory(chttrans)
add_subdirectory(punc)
add_subdirectory(spell)
add_subdirectory(pinyin-enhance)
add_subdirectory(quickphrase)
add_subdirectory(autoeng)
add_subdirectory(fullwidthchar)
add_subdirectory(remote)
add_subdirectory(imselector)
if (_ENABLE_CAIRO)
    add_subdirectory(vk)
endif (_ENABLE_CAIRO)

if (_ENABLE_DBUS)
    add_subdirectory(dbus)
endif (_ENABLE_DBUS)

if (ENABLE_LUA)
    add_subdirectory(lua)
endif (ENABLE_LUA)
add_subdirectory(unicode)

=== src/im/table/CMakeLists.txt ===

set(FCITX_TABLE_SOURCES
    tabledict.c
    tablepinyinwrapper.c
    table.c
    tableconfig.c
)

fcitx_add_addon(fcitx-table ${FCITX_TABLE_SOURCES})
fcitx_add_addon_conf_file(fcitx-table.conf)
fcitx_add_configdesc_file(table.desc)
fcitx_add_configdesc_file(fcitx-table.desc)

=== src/lib/fcitx-gclient/CMakeLists.txt ===
_pkgconfig_invoke("glib-2.0" GLIB2 GLIB_GENMARSHAL "" "--variable=glib_genmarshal")
FIND_PROGRAM(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})

include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GIO2_LIBRARY_DIRS})
link_directories(${DBUS_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
                   DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
                   DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list
)

set(FCITX_GCLIENT_SOURCES
    fcitxclient.c
    fcitxinputmethod.c
    fcitxkbd.c
)

set(FCITX_GCLIENT_BUILT_SOURCES
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
)

set(FCITX_GCLIENT_HEADERS
    fcitxclient.h
    fcitxinputmethod.h
    fcitxkbd.h
)

set(FCITX_GCLIENT_BUILT_HEADERS
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(fcitx-gclient SHARED ${FCITX_GCLIENT_SOURCES} ${FCITX_GCLIENT_BUILT_SOURCES} ${FCITX_GCLIENT_BUILT_HEADERS})
set_target_properties(fcitx-gclient
                      PROPERTIES VERSION 0.1
                      SOVERSION 0
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)
target_link_libraries(fcitx-gclient ${GIO2_LIBRARIES} ${DBUS_LIBRARIES} fcitx-utils)

configure_file(fcitx-gclient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-gclient.pc)

install(TARGETS fcitx-gclient LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-gclient.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_GCLIENT_HEADERS} DESTINATION "${includedir}/fcitx-gclient")

if (ENABLE_GIR)

include(GObjectIntrospection)

gobject_introspection(
    FILENAME Fcitx-1.0.gir
    NSVERSION 1.0
    INCLUDE Gio-2.0 GObject-2.0 GLib-2.0
    PACKAGE_EXPORT fcitx-gclient
    LIBRARY fcitx-gclient
    SCANNER_ARGS --warn-all --add-include-path=${CMAKE_CURRENT_SOURCE_DIR}
    COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}"
    SYMBOL_PREFIXES fcitx
    SOURCES ${FCITX_GCLIENT_SOURCES} ${FCITX_GCLIENT_HEADERS}
)



install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx-1.0.gir DESTINATION ${GOBJECT_INTROSPECTION_GIRDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx-1.0.typelib DESTINATION ${GOBJECT_INTROSPECTION_TYPELIBDIR})

endif (ENABLE_GIR)

if (ENABLE_STATIC)

add_library(fcitx-gclient-static STATIC ${FCITX_GCLIENT_SOURCES})
set_target_properties(fcitx-gclient-static PROPERTIES
    OUTPUT_NAME "fcitx-gclient"
    PREFIX "lib"
)

install(TARGETS fcitx-gclient-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

add_subdirectory(test)

=== src/lib/fcitx-utils/CMakeLists.txt ===
set(FCITX_UTILS_SOURCES
    utf8.c
    utils.c
    log.c
    qsort_r.c
    msort_r.c
    memory.c
)

set(FCITX_UTILS_HEADERS
    log.h
    utarray.h
    utf8.h
    utils.h
    uthash.h
    memory.h
    keysym.h
    keysymgen.h
    bitset.h
)

if (LIBKVM_FOUND)
    include_directories(LIBKVM_INCLUDE_DIR)
endif (LIBKVM_FOUND)

add_library(fcitx-utils SHARED ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils
                      PROPERTIES VERSION 0.1
                      SOVERSION 0
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)
target_link_libraries(fcitx-utils ${LIBINTL_LIBRARIES} ${LIBICONV_LIBRARIES} ${LIBEXECINFO_LIBRARIES})

if (LIBKVM_FOUND)
    target_link_libraries(fcitx-utils ${LIBKVM_LIBRARIES})
endif (LIBKVM_FOUND)

configure_file(fcitx-utils.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc)

install(TARGETS fcitx-utils LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${includedir}/fcitx-utils")

if (ENABLE_STATIC)

add_library(fcitx-utils-static STATIC ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils-static PROPERTIES
    OUTPUT_NAME "fcitx-utils"
    PREFIX "lib"
)

install(TARGETS fcitx-utils-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== src/module/unicode/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)

set(FCITX_UNICODE_SOURCES
    unicode.c
    charselectdata.c
)

fcitx_add_addon(fcitx-unicode ${FCITX_UNICODE_SOURCES})
fcitx_add_configdesc_file(fcitx-unicode.desc)
fcitx_add_addon_conf_file(fcitx-unicode.conf)

install(FILES charselectdata DESTINATION ${pkgdatadir}/data/)

=== src/module/x11/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${X11_X11_INCLUDE_PATH})

set(FCITX_X11_SOURCES
    xerrorhandler.c
    x11stuff.c
)

fcitx_add_addon(fcitx-x11 ${FCITX_X11_SOURCES})
target_link_libraries( fcitx-x11 ${X11_LIBRARIES} ${X11_Xrender_LIB})

if (HAVE_XINERAMA)
    target_link_libraries( fcitx-x11 ${X11_Xinerama_LIB} )
endif (HAVE_XINERAMA)

if (HAVE_XFIXES)
    target_link_libraries( fcitx-x11 ${X11_Xfixes_LIB} )
endif (HAVE_XFIXES)

fcitx_add_addon_header(x11 x11stuff.h)
fcitx_add_addon_conf_file(fcitx-x11.conf)

=== debian/changelog ===
fcitx (1:4.2.6.1-2) experimental; urgency=low

  * Update debian/control
  * Fix build on GNU/Hurd.

 -- Aron Xu <aron@debian.org>  Sat, 01 Dec 2012 15:36:33 +0800

fcitx (1:4.2.6.1-1) experimental; urgency=low

  * New upstream bug fix release.

 -- Aron Xu <aron@debian.org>  Wed, 03 Oct 2012 22:33:51 +0800

fcitx (1:4.2.6-1) experimental; urgency=low

  * New upstream release. 

 -- YunQiang Su <wzssyqa@gmail.com>  Mon, 24 Sep 2012 20:16:40 +0800

fcitx (1:4.2.5-1~exp) experimental; urgency=low

  * New upstream release.

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 19 Jul 2012 19:25:18 +0800

=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 9), cmake, intltool (>= 0.35.0), liblua5.1-0-dev,
    libdbus-1-dev (>= 1.1.0), libpango1.0-dev (>= 1.0), libcairo2-dev (>= 1.0),
    libopencc-dev (>= 0.1.1~), libicu-dev, x11proto-xinerama-dev,
    libgtk2.0-dev, libqt4-dev, libgtk-3-dev, libkvm-dev [kfreebsd-any],
    libenchant-dev, libpresage-dev, libxml2-dev, libxkbfile-dev, gobject-introspection,
    libgirepository1.0-dev, iso-codes, libxfixes-dev
Standards-Version: 3.9.4
Homepage: http://code.google.com/p/fcitx/
Vcs-Git: git://git.debian.org/pkg-ime/fcitx.git
Vcs-Browser: http://git.debian.org/?p=pkg-ime/fcitx.git

Package: fcitx
Architecture: all
Depends: ${misc:Depends}, fcitx-bin, fcitx-data, fcitx-modules
Recommends: fcitx-config-gtk | kde-config-fcitx,
    fcitx-frontend-all | fcitx-frontend-fbterm,
    fcitx-ui-classic | fcitx-ui-light,
    im-config (>= 0.5) | im-switch
Suggests: fcitx-tools, fcitx-m17n
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= 1:4.2.6)
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package 
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= 1:4.2.6)
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fcitx (>= 1:4.2.6)
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - library files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains three libraries:
  * libfcitx-core - core functions of Fcitx
  * libfcitx-config - support library for Fcitx configurations
  * libfcitx-utils - utility support library for Fcitx

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: gir1.2-fcitx-1.0
Architecture: any
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}
Suggests: fcitx (>= 1:4.2.6)
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - GObject introspection 
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

Package: fcitx-dbg
Architecture: any
Section: debug
Priority: extra
Multi-Arch: same
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - debugging symbols
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the debugging symbols of the whole Fcitx.

Package: fcitx-ui-classic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-x11
Recommends: fcitx (>= 1:4.2.6), zenity
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the classic user interface, which is suitable 
 for most users. It also provides the following skins:
  * classic: Fcitx 3.x classic skin ported to new infrastructure
  * dark: the dark skin fits for dark desktop theme
  * default: the default skin

Package: fcitx-frontend-all
Architecture: all
Depends: ${misc:Depends}
Recommends: fcitx-frontend-gtk2, fcitx-frontend-gtk3, fcitx-frontend-qt4
Description: Flexible Input Method Framework - frontends metapackage
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in the following frontends:
  * XIM protocol client
  * GTK+ 2/3 IM Module
  * QT 4 IM Module

Package: fcitx-frontend-gtk2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk3
Description: Flexible Input Method Framework - GTK+ 2 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 2 IM Module frontend, which is
 recommended for all desktop users.

Package: fcitx-frontend-gtk3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk2
Description: Flexible Input Method Framework - GTK+ 3 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 3 IM Module frontend, which is
 recommended for all desktop users. This is the best solution if you are
 looking for a better input experience with GTK+ 3 applications.

Package: fcitx-frontend-qt4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Description: Flexible Input Method Framework - Qt4 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the QT 4 IM Module frontend, which is recommended
 for KDE4 desktop users.

Package: fcitx-pinyin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-bin,
  fcitx-data (>= 1:4.2.6), fcitx-modules
Recommends: fcitx (>= 1:4.2.6)
Replaces: fcitx (<< 1:4.2.6)
Breaks: fcitx (<< 1:4.2.6)
Description: Flexible Input Method Framework - classic Pinyin engine
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
